From deec5cfd5e46000d3cbad724e49eb3b4d8e9ceac Mon Sep 17 00:00:00 2001
From: Fei Xu <xufei30@huawei.com>
Date: Fri, 26 Feb 2021 10:02:35 +0800
Subject: [PATCH 2/4] StratoVirt: Update the binary version and crate version
 to 0.2.0

Signed-off-by: Fei Xu <xufei30@huawei.com>
---
 Cargo.lock                 | 36 ++++++++++++++++++------------------
 Cargo.toml                 |  2 +-
 address_space/Cargo.toml   |  2 +-
 boot_loader/Cargo.toml     |  2 +-
 device_model/Cargo.toml    |  2 +-
 machine_manager/Cargo.toml |  2 +-
 util/Cargo.toml            |  2 +-
 7 files changed, 24 insertions(+), 24 deletions(-)

diff --git a/Cargo.lock b/Cargo.lock
index 2d64997..fe913a5 100644
--- a/Cargo.lock
+++ b/Cargo.lock
@@ -2,14 +2,14 @@
 # It is not intended for manual editing.
 [[package]]
 name = "StratoVirt"
-version = "0.1.0"
+version = "0.2.0"
 dependencies = [
- "device_model 0.1.0",
+ "device_model 0.2.0",
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
  "log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)",
- "machine_manager 0.1.0",
- "util 0.1.0",
+ "machine_manager 0.2.0",
+ "util 0.2.0",
  "vmm-sys-util 0.6.1 (registry+https://github.com/rust-lang/crates.io-index)",
 ]
 
@@ -23,15 +23,15 @@ dependencies = [
 
 [[package]]
 name = "address_space"
-version = "0.1.0"
+version = "0.2.0"
 dependencies = [
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-ioctls 0.6.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
  "log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)",
- "machine_manager 0.1.0",
- "util 0.1.0",
+ "machine_manager 0.2.0",
+ "util 0.2.0",
  "vmm-sys-util 0.6.1 (registry+https://github.com/rust-lang/crates.io-index)",
 ]
 
@@ -60,15 +60,15 @@ source = "registry+https://github.com/rust-lang/crates.io-index"
 
 [[package]]
 name = "boot_loader"
-version = "0.1.0"
+version = "0.2.0"
 dependencies = [
- "address_space 0.1.0",
+ "address_space 0.2.0",
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-ioctls 0.6.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
  "log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)",
- "util 0.1.0",
+ "util 0.2.0",
  "vmm-sys-util 0.6.1 (registry+https://github.com/rust-lang/crates.io-index)",
 ]
 
@@ -84,20 +84,20 @@ source = "registry+https://github.com/rust-lang/crates.io-index"
 
 [[package]]
 name = "device_model"
-version = "0.1.0"
+version = "0.2.0"
 dependencies = [
- "address_space 0.1.0",
- "boot_loader 0.1.0",
+ "address_space 0.2.0",
+ "boot_loader 0.2.0",
  "byteorder 1.3.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-ioctls 0.6.0 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
  "log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)",
- "machine_manager 0.1.0",
+ "machine_manager 0.2.0",
  "serde 1.0.114 (registry+https://github.com/rust-lang/crates.io-index)",
  "serde_json 1.0.55 (registry+https://github.com/rust-lang/crates.io-index)",
- "util 0.1.0",
+ "util 0.2.0",
  "vmm-sys-util 0.6.1 (registry+https://github.com/rust-lang/crates.io-index)",
 ]
 
@@ -153,14 +153,14 @@ dependencies = [
 
 [[package]]
 name = "machine_manager"
-version = "0.1.0"
+version = "0.2.0"
 dependencies = [
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "libc 0.2.71 (registry+https://github.com/rust-lang/crates.io-index)",
  "log 0.4.8 (registry+https://github.com/rust-lang/crates.io-index)",
  "serde 1.0.114 (registry+https://github.com/rust-lang/crates.io-index)",
  "serde_json 1.0.55 (registry+https://github.com/rust-lang/crates.io-index)",
- "util 0.1.0",
+ "util 0.2.0",
  "vmm-sys-util 0.6.1 (registry+https://github.com/rust-lang/crates.io-index)",
 ]
 
@@ -248,7 +248,7 @@ source = "registry+https://github.com/rust-lang/crates.io-index"
 
 [[package]]
 name = "util"
-version = "0.1.0"
+version = "0.2.0"
 dependencies = [
  "error-chain 0.12.4 (registry+https://github.com/rust-lang/crates.io-index)",
  "kvm-bindings 0.3.0 (registry+https://github.com/rust-lang/crates.io-index)",
diff --git a/Cargo.toml b/Cargo.toml
index 99881c9..ad1c31e 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -1,6 +1,6 @@
 [package]
 name = "StratoVirt"
-version = "0.1.0"
+version = "0.2.0"
 authors = ["Huawei StratoVirt Team"]
 edition = "2018"
 description = "a lightweight hypervisor with low memory overhead and fast booting speed"
diff --git a/address_space/Cargo.toml b/address_space/Cargo.toml
index a029742..ccbae7c 100644
--- a/address_space/Cargo.toml
+++ b/address_space/Cargo.toml
@@ -1,6 +1,6 @@
 [package]
 name = "address_space"
-version = "0.1.0"
+version = "0.2.0"
 authors = ["Huawei StratoVirt Team"]
 edition = "2018"
 license = "Mulan PSL v2"
diff --git a/boot_loader/Cargo.toml b/boot_loader/Cargo.toml
index 5f3a32a..21d571f 100644
--- a/boot_loader/Cargo.toml
+++ b/boot_loader/Cargo.toml
@@ -1,6 +1,6 @@
 [package]
 name = "boot_loader"
-version = "0.1.0"
+version = "0.2.0"
 authors = ["Huawei StratoVirt Team"]
 edition = "2018"
 license = "Mulan PSL v2"
diff --git a/device_model/Cargo.toml b/device_model/Cargo.toml
index b165c8c..d820d4f 100644
--- a/device_model/Cargo.toml
+++ b/device_model/Cargo.toml
@@ -1,6 +1,6 @@
 [package]
 name = "device_model"
-version = "0.1.0"
+version = "0.2.0"
 authors = ["Huawei StratoVirt Team"]
 edition = "2018"
 license = "Mulan PSL v2"
diff --git a/machine_manager/Cargo.toml b/machine_manager/Cargo.toml
index 0f543c6..38cce38 100644
--- a/machine_manager/Cargo.toml
+++ b/machine_manager/Cargo.toml
@@ -1,6 +1,6 @@
 [package]
 name = "machine_manager"
-version = "0.1.0"
+version = "0.2.0"
 authors = ["Huawei StratoVirt Team"]
 edition = "2018"
 license = "Mulan PSL v2"
diff --git a/util/Cargo.toml b/util/Cargo.toml
index 857e37c..97ddc08 100644
--- a/util/Cargo.toml
+++ b/util/Cargo.toml
@@ -1,6 +1,6 @@
 [package]
 name = "util"
-version = "0.1.0"
+version = "0.2.0"
 authors = ["Huawei StratoVirt Team"]
 edition = "2018"
 license = "Mulan PSL v2"
-- 
2.27.0